// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#pragma once
#include <string>
#include <vector>

#include "cfg.h"
#include "interface.h"
#include "source.h"
#include "gen.h"

typedef struct {
	std::string id;
	pos_t pos; // currently only for PIP views
} view_src_t;

class view : public source
{
protected:
	configuration_t *const cfg;
	const std::vector<view_src_t> sources;

public:
	view(configuration_t *const cfg, const std::string & id, const std::string & descr, const int width, const int height, resize *const r, const std::vector<view_src_t> & sources, std::vector<filter *> *const filters);
	view(configuration_t *const cfg, const std::string & id, const std::string & descr, const int width, const int height, resize *const r, const std::vector<view_src_t> & sources);
	virtual ~view();

	virtual std::string get_html(const std::map<std::string, std::string> & pars) const = 0;

	virtual bool get_frame(const encoding_t pe, const int jpeg_quality, uint64_t *ts, int *width, int *height, uint8_t **frame, size_t *frame_len, const bool repeat) override { return false; }

	virtual source *get_current_source();

	virtual void operator()() override;
};

view *find_view(instance_t *const inst);
